SUBROUTINE calculkz(klev,pphi,theta,vitv,vitu,kz)
USE ioipsl, only : getin
IMPLICIT NONE
!déclaration des variables
integer klev
integer k
integer, save :: flag_kz=0
real pphi(klev), vitu(klev), vitv(klev)
real theta(klev), z(klev), diffz(klev), lmix(klev)
real g, emin, Ric
real,save :: lmix0=20
real kz(klev+1), M(klev+1), N2(klev+1), Ri(klev+1) 

logical, save :: first=.true.

if (first) then
    call getin('flag_kz',flag_kz)
    first=.false.
endif

g=9.81
emin=1e-12
Ric=0.25

do k=1,klev
   z(k)=pphi(k)/g
enddo

! Calcul du coefficient de diffusion turbulente
if(flag_kz==0)then
  do k=1,klev
     kz(k)=2.*(1.-tanh(2.*(k-klev*5./6.)))/2.
  enddo
! Calcul de Kz amélioré avec Ri=0
else if(flag_kz==1) then
  do k=1,klev-1
    lmix(k+1)=lmix0*(z(k+1)+z(k))/(2*(lmix0+((z(k)+z(k+1))/2)))
    diffz(k+1)=(z(k+1)-z(k))**2
    M(k+1)=((vitv(k+1)-vitv(k))**2+(vitu(k+1)-vitu(k))**2)/diffz(k+1)
    kz(k+1)=lmix(k+1)*sqrt(max(M(k+1),emin))
  end do
! Calcul de Kz amélioré avec Ri différent de 0
else if(flag_kz==2) then
  do k=1,klev-1
    lmix(k+1)=lmix0*(z(k+1)+z(k))/(2*(lmix0+((z(k)+z(k+1))/2)))
    diffz(k+1)=(z(k+1)-z(k))**2
    M(k+1)=(emin+(vitv(k+1)-vitv(k))**2+(vitu(k+1)-vitu(k))**2)/diffz(k+1)
    N2(k+1)=(g/theta(k))*(theta(k+1)-theta(k))/(z(k+1)-z(k))
    Ri(k+1)=N2(k+1)/M(k+1)
    kz(k+1)=lmix(k+1)*sqrt(max(M(k+1)*(1-(Ri(k+1)/Ric)),emin))
  end do
end if

END SUBROUTINE calculkz
